## shim 15.4

=== Makefile ===
default : all

NAME		= shim
VERSION		= 15.4
ifneq ($(origin RELEASE),undefined)
DASHRELEASE	?= -$(RELEASE)
else
DASHRELEASE	?=
endif

ifeq ($(MAKELEVEL),0)
TOPDIR		?= $(shell pwd)
endif
ifeq ($(TOPDIR),)
override TOPDIR := $(shell pwd)
endif
override TOPDIR	:= $(abspath $(TOPDIR))
VPATH		= $(TOPDIR)
export TOPDIR

include $(TOPDIR)/Make.rules
include $(TOPDIR)/Make.defaults
include $(TOPDIR)/include/coverity.mk
include $(TOPDIR)/include/scan-build.mk
include $(TOPDIR)/include/fanalyzer.mk

TARGETS	= $(SHIMNAME)
TARGETS += $(SHIMNAME).debug $(MMNAME).debug $(FBNAME).debug
ifneq ($(origin ENABLE_SHIM_HASH),undefined)
TARGETS += $(SHIMHASHNAME)
endif
ifneq ($(origin ENABLE_SHIM_DEVEL),undefined)
CFLAGS += -DENABLE_SHIM_DEVEL
endif
ifneq ($(origin ENABLE_SHIM_CERT),undefined)
TARGETS	+= $(MMNAME).signed $(FBNAME).signed
CFLAGS += -DENABLE_SHIM_CERT
else
TARGETS += $(MMNAME) $(FBNAME)
endif
OBJS	= shim.o mok.o netboot.o cert.o replacements.o tpm.o version.o errlog.o sbat.o sbat_data.o pe.o httpboot.o csv.o
KEYS	= shim_cert.h ocsp.* ca.* shim.crt shim.csr shim.p12 shim.pem shim.key shim.cer
ORIG_SOURCES	= shim.c mok.c netboot.c replacements.c tpm.c errlog.c sbat.c pe.c httpboot.c shim.h version.h $(wildcard include/*.h)
MOK_OBJS = MokManager.o PasswordCrypt.o crypt_blowfish.o errlog.o sbat_data.o
ORIG_MOK_SOURCES = MokManager.c PasswordCrypt.c crypt_blowfish.c shim.h $(wildcard include/*.h)
FALLBACK_OBJS = fallback.o tpm.o errlog.o sbat_data.o
ORIG_FALLBACK_SRCS = fallback.c
SBATPATH = $(TOPDIR)/data/sbat.csv

ifeq ($(SOURCE_DATE_EPOCH),)
	UNAME=$(shell uname -s -m -p -i -o)
else
	UNAME=buildhost
endif

SOURCES = $(foreach source,$(ORIG_SOURCES),$(TOPDIR)/$(source)) version.c
MOK_SOURCES = $(foreach source,$(ORIG_MOK_SOURCES),$(TOPDIR)/$(source))
FALLBACK_SRCS = $(foreach source,$(ORIG_FALLBACK_SRCS),$(TOPDIR)/$(source))

ifneq ($(origin FALLBACK_VERBOSE), undefined)
	CFLAGS += -DFALLBACK_VERBOSE
endif

ifneq ($(origin FALLBACK_VERBOSE_WAIT), undefined)
	CFLAGS += -DFALLBACK_VERBOSE_WAIT=$(FALLBACK_VERBOSE_WAIT)
endif

all: confcheck $(TARGETS)

confcheck:
ifneq ($(origin EFI_PATH),undefined)
	$(error EFI_PATH is no longer supported, you must build using the supplied copy of gnu-efi)
endif

update :
	git submodule update --init --recursive

shim.crt:
	$(TOPDIR)/make-certs shim shim@xn--u4h.net all codesign 1.3.6.1.4.1.311.10.3.1 </dev/null

shim.cer: shim.crt
	$(OPENSSL) x509 -outform der -in $< -out $@

.NOTPARALLEL: shim_cert.h
shim_cert.h: shim.cer
	echo "static UINT8 shim_cert[] __attribute__((__unused__)) = {" > $@
	$(HEXDUMP) -v -e '1/1 "0x%02x, "' $< >> $@
	echo "};" >> $@

version.c : $(TOPDIR)/version.c.in
	sed	-e "s,@@VERSION@@,$(VERSION)," \
		-e "s,@@UNAME@@,$(UNAME)," \
		-e "s,@@COMMIT@@,$(COMMIT_ID)," \
		< $< > $@

certdb/secmod.db: shim.crt
	-mkdir certdb
	$(PK12UTIL) -d certdb/ -i shim.p12 -W "" -K ""
	$(CERTUTIL) -d certdb/ -A -i shim.crt -n shim -t u

shim.o: $(SOURCES)
ifneq ($(origin ENABLE_SHIM_CERT),undefined)
shim.o: shim_cert.h
endif
shim.o: $(wildcard $(TOPDIR)/*.h)

cert.o : $(TOPDIR)/cert.S
	$(CC) $(CFLAGS) -c -o $@ $<

sbat.%.csv : data/sbat.%.csv
	$(DOS2UNIX) $(D2UFLAGS) $< $@
	tail -c1 $@ | read -r _ || echo >> $@ # ensure a trailing newline

VENDOR_SBATS := $(sort $(foreach x,$(wildcard $(TOPDIR)/data/sbat.*.csv data/sbat.*.csv),$(notdir $(x))))

sbat_data.o : | $(SBATPATH) $(VENDOR_SBATS)
sbat_data.o : /dev/null
	$(CC) $(CFLAGS) -x c -c -o $@ $<
	$(OBJCOPY) --add-section .sbat=$(SBATPATH) \
		--set-section-flags .sbat=contents,alloc,load,readonly,data \
		$@
	$(foreach vs,$(VENDOR_SBATS),$(call add-vendor-sbat,$(vs),$@))

$(SHIMNAME) : $(SHIMSONAME)
$(MMNAME) : $(MMSONAME)
$(FBNAME) : $(FBSONAME)

LIBS = Cryptlib/libcryptlib.a \
       Cryptlib/OpenSSL/libopenssl.a \
       lib/lib.a \
       gnu-efi/$(ARCH_GNUEFI)/lib/libefi.a \
       gnu-efi/$(ARCH_GNUEFI)/gnuefi/libgnuefi.a

$(SHIMSONAME): $(OBJS) $(LIBS)
	$(LD) -o $@ $(LDFLAGS) $^ $(EFI_LIBS) lib/lib.a

fallback.o: $(FALLBACK_SRCS)

$(FBSONAME): $(FALLBACK_OBJS) $(LIBS)
	$(LD) -o $@ $(LDFLAGS) $^ $(EFI_LIBS) lib/lib.a

MokManager.o: $(MOK_SOURCES)

$(MMSONAME): $(MOK_OBJS) $(LIBS)
	$(LD) -o $@ $(LDFLAGS) $^ $(EFI_LIBS) lib/lib.a

gnu-efi/$(ARCH_GNUEFI)/gnuefi/libgnuefi.a gnu-efi/$(ARCH_GNUEFI)/lib/libefi.a: CFLAGS+=-DGNU_EFI_USE_EXTERNAL_STDARG
gnu-efi/$(ARCH_GNUEFI)/gnuefi/libgnuefi.a gnu-efi/$(ARCH_GNUEFI)/lib/libefi.a:
	mkdir -p gnu-efi/lib gnu-efi/gnuefi
	$(MAKE) -C gnu-efi \
		ARCH=$(ARCH_GNUEFI) TOPDIR=$(TOPDIR)/gnu-efi \
		-f $(TOPDIR)/gnu-efi/Makefile \
		lib gnuefi inc

Cryptlib/libcryptlib.a:
	for i in Hash Hmac Cipher Rand Pk Pem SysCall; do mkdir -p Cryptlib/$$i; done
	$(MAKE) TOPDIR=$(TOPDIR) VPATH=$(TOPDIR)/Cryptlib -C Cryptlib -f $(TOPDIR)/Cryptlib/Makefile

Cryptlib/OpenSSL/libopenssl.a:
	for i in x509v3 x509 txt_db stack sha rsa rc4 rand pkcs7 pkcs12 pem ocsp objects modes md5 lhash kdf hmac evp err dso dh conf comp cmac buffer bn bio async/arch asn1 aes; do mkdir -p Cryptlib/OpenSSL/crypto/$$i; done
	$(MAKE) TOPDIR=$(TOPDIR) VPATH=$(TOPDIR)/Cryptlib/OpenSSL -C Cryptlib/OpenSSL -f $(TOPDIR)/Cryptlib/OpenSSL/Makefile

lib/lib.a: | $(TOPDIR)/lib/Makefile $(wildcard $(TOPDIR)/include/*.[ch])
	mkdir -p lib
	$(MAKE) VPATH=$(TOPDIR)/lib TOPDIR=$(TOPDIR) -C lib -f $(TOPDIR)/lib/Makefile

buildid : $(TOPDIR)/buildid.c
	$(HOSTCC) -I/usr/include -Og -g3 -Wall -Werror -Wextra -o $@ $< -lelf

$(BOOTCSVNAME) :
	@echo Making $@
	@echo "$(SHIMNAME),$(OSLABEL),,This is the boot entry for $(OSLABEL)" | iconv -t UCS-2LE > $@

install-check :
ifeq ($(origin LIBDIR),undefined)
	$(error Architecture $(ARCH) is not a supported build target.)
endif
ifeq ($(origin EFIDIR),undefined)
	$(error EFIDIR must be set to your reserved EFI System Partition subdirectory name)
endif

install-deps : $(TARGETS)
install-deps : $(SHIMNAME).debug $(MMNAME).debug $(FBNAME).debug buildid
install-deps : $(BOOTCSVNAME)

install-debugsource : install-deps
	$(INSTALL) -d -m 0755 $(DESTDIR)/$(DEBUGSOURCE)/$(PKGNAME)-$(VERSION)$(DASHRELEASE)
	find $(TOPDIR) -type f -a '(' -iname '*.c' -o -iname '*.h' -o -iname '*.S' ')' | while read file ; do \
		outfile=$$(echo $${file} | sed -e "s,^$(TOPDIR),,") ; \
		$(INSTALL) -d -m 0755 $(DESTDIR)/$(DEBUGSOURCE)/$(PKGNAME)-$(VERSION)$(DASHRELEASE)/$$(dirname $${outfile}) ; \
		$(INSTALL) -m 0644 $${file} $(DESTDIR)/$(DEBUGSOURCE)/$(PKGNAME)-$(VERSION)$(DASHRELEASE)/$${outfile} ; \
	done

install-debuginfo : install-deps
	$(INSTALL) -d -m 0755 $(DESTDIR)/
	$(INSTALL) -d -m 0755 $(DESTDIR)/$(DEBUGINFO)$(TARGETDIR)/
	@./buildid $(wildcard *.efi.debug) | while read file buildid ; do \
		first=$$(echo $${buildid} | cut -b -2) ; \
		rest=$$(echo $${buildid} | cut -b 3-) ; \
		$(INSTALL) -d -m 0755 $(DESTDIR)/$(DEBUGINFO).build-id/$${first}/ ;\
		$(INSTALL) -m 0644 $${file} $(DESTDIR)/$(DEBUGINFO)$(TARGETDIR) ; \
		ln -s ../../../../..$(DEBUGINFO)$(TARGETDIR)$${file} $(DESTDIR)/$(DEBUGINFO).build-id/$${first}/$${rest}.debug ;\
		ln -s ../../../.build-id/$${first}/$${rest} $(DESTDIR)/$(DEBUGINFO).build-id/$${first}/$${rest} ;\
	done

install : | install-check
install : install-deps install-debuginfo install-debugsource
	$(INSTALL) -d -m 0755 $(DESTDIR)/
	$(INSTALL) -d -m 0700 $(DESTDIR)/$(ESPROOTDIR)
	$(INSTALL) -d -m 0755 $(DESTDIR)/$(EFIBOOTDIR)
	$(INSTALL) -d -m 0755 $(DESTDIR)/$(TARGETDIR)
	$(INSTALL) -m 0644 $(SHIMNAME) $(DESTDIR)/$(EFIBOOTDIR)/$(BOOTEFINAME)
	$(INSTALL) -m 0644 $(SHIMNAME) $(DESTDIR)/$(TARGETDIR)/
	$(INSTALL) -m 0644 $(BOOTCSVNAME) $(DESTDIR)/$(TARGETDIR)/
ifneq ($(origin ENABLE_SHIM_CERT),undefined)
	$(INSTALL) -m 0644 $(FBNAME).signed $(DESTDIR)/$(EFIBOOTDIR)/$(FBNAME)
	$(INSTALL) -m 0644 $(MMNAME).signed $(DESTDIR)/$(EFIBOOTDIR)/$(MMNAME)
	$(INSTALL) -m 0644 $(MMNAME).signed $(DESTDIR)/$(TARGETDIR)/$(MMNAME)
else
	$(INSTALL) -m 0644 $(FBNAME) $(DESTDIR)/$(EFIBOOTDIR)/
	$(INSTALL) -m 0644 $(MMNAME) $(DESTDIR)/$(EFIBOOTDIR)/
	$(INSTALL) -m 0644 $(MMNAME) $(DESTDIR)/$(TARGETDIR)/
endif

install-as-data : install-deps
	$(INSTALL) -d -m 0755 $(DESTDIR)/$(DATATARGETDIR)
	$(INSTALL) -m 0644 $(SHIMNAME) $(DESTDIR)/$(DATATARGETDIR)/
	$(INSTALL) -m 0644 $(BOOTCSVNAME) $(DESTDIR)/$(DATATARGETDIR)/
ifneq ($(origin ENABLE_SHIM_HASH),undefined)
	$(INSTALL) -m 0644 $(SHIMHASHNAME) $(DESTDIR)/$(DATATARGETDIR)/
endif
ifneq ($(origin ENABLE_SHIM_CERT),undefined)
	$(INSTALL) -m 0644 $(MMNAME).signed $(DESTDIR)/$(DATATARGETDIR)/$(MMNAME)
	$(INSTALL) -m 0644 $(FBNAME).signed $(DESTDIR)/$(DATATARGETDIR)/$(FBNAME)
else
	$(INSTALL) -m 0644 $(MMNAME) $(DESTDIR)/$(DATATARGETDIR)/$(MMNAME)
	$(INSTALL) -m 0644 $(FBNAME) $(DESTDIR)/$(DATATARGETDIR)/$(FBNAME)
endif

%.efi: %.so
ifneq ($(OBJCOPY_GTE224),1)
	$(error objcopy >= 2.24 is required)
endif
	$(OBJCOPY) -D -j .text -j .sdata -j .data -j .data.ident \
		-j .dynamic -j .rodata -j .rel* \
		-j .rela* -j .reloc -j .eh_frame \
		-j .vendor_cert -j .sbat \
		$(FORMAT) $< $@
	# I am tired of wasting my time fighting binutils timestamp code.
	dd conv=notrunc bs=1 count=4 seek=$(TIMESTAMP_LOCATION) if=/dev/zero of=$@

ifneq ($(origin ENABLE_SHIM_HASH),undefined)
%.hash : %.efi
	$(PESIGN) -i $< -P -h > $@
endif

%.efi.debug : %.so
ifneq ($(OBJCOPY_GTE224),1)
	$(error objcopy >= 2.24 is required)
endif
	$(OBJCOPY) -D -j .text -j .sdata -j .data \
		-j .dynamic -j .rodata -j .rel* \
		-j .rela* -j .reloc -j .eh_frame -j .sbat \
		-j .debug_info -j .debug_abbrev -j .debug_aranges \
		-j .debug_line -j .debug_str -j .debug_ranges \
		-j .note.gnu.build-id \
		$< $@

ifneq ($(origin ENABLE_SBSIGN),undefined)
%.efi.signed: %.efi shim.key shim.crt
	@$(SBSIGN) \
		--key shim.key \
		--cert shim.crt \
		--output $@ $<
else
%.efi.signed: %.efi certdb/secmod.db
	$(PESIGN) -n certdb -i $< -c "shim" -s -o $@ -f
endif

test :
	@make -f $(TOPDIR)/include/test.mk EFI_INCLUDES="$(EFI_INCLUDES)" ARCH_DEFINES="$(ARCH_DEFINES)" all

$(patsubst %.c,%,$(wildcard test-*.c)) :
	@make -f $(TOPDIR)/include/test.mk EFI_INCLUDES="$(EFI_INCLUDES)" ARCH_DEFINES="$(ARCH_DEFINES)" $@

.PHONY : $(patsubst %.c,%,$(wildcard test-*.c)) test

clean-test-objs:
	@make -f $(TOPDIR)/include/test.mk EFI_INCLUDES="$(EFI_INCLUDES)" ARCH_DEFINES="$(ARCH_DEFINES)" clean

clean-gnu-efi:
	@if [ -d gnu-efi ] ; then \
		$(MAKE) -C gnu-efi \
			ARCH=$(ARCH_GNUEFI) TOPDIR=$(TOPDIR)/gnu-efi \
			-f $(TOPDIR)/gnu-efi/Makefile \
			clean ; \
	fi

clean-lib-objs:
	@if [ -d lib ] ; then \
		$(MAKE) -C lib TOPDIR=$(TOPDIR) -f $(TOPDIR)/lib/Makefile clean ; \
	fi

clean-shim-objs:
	@rm -rvf $(TARGET) *.o $(SHIM_OBJS) $(MOK_OBJS) $(FALLBACK_OBJS) $(KEYS) certdb $(BOOTCSVNAME)
	@rm -vf *.debug *.so *.efi *.efi.* *.tar.* version.c buildid
	@rm -vf Cryptlib/*.[oa] Cryptlib/*/*.[oa]
	@if [ -d .git ] ; then git clean -f -d -e 'Cryptlib/OpenSSL/*'; fi

clean-openssl-objs:
	@if [ -d Cryptlib/OpenSSL ] ; then \
		$(MAKE) -C Cryptlib/OpenSSL -f $(TOPDIR)/Cryptlib/OpenSSL/Makefile clean ; \
	fi

clean-cryptlib-objs:
	@if [ -d Cryptlib ] ; then \
		$(MAKE) -C Cryptlib -f $(TOPDIR)/Cryptlib/Makefile clean ; \
	fi

clean: clean-shim-objs clean-test-objs clean-gnu-efi clean-openssl-objs clean-cryptlib-objs clean-lib-objs

GITTAG = $(VERSION)

test-archive:
	@./make-archive $(if $(call get-config,shim.origin),--origin "$(call get-config,shim.origin)") --test "$(VERSION)"

tag:
	git tag --sign $(GITTAG) refs/heads/main
	git tag -f latest-release $(GITTAG)

archive: tag
	@./make-archive $(if $(call get-config,shim.origin),--origin "$(call get-config,shim.origin)") --release "$(VERSION)" "$(GITTAG)" "shim-$(GITTAG)"

.PHONY : install-deps shim.key

export ARCH CC CROSS_COMPILE LD OBJCOPY EFI_INCLUDE EFI_INCLUDES OPTIMIZATIONS
export FEATUREFLAGS WARNFLAGS WERRFLAGS

=== debian/changelog ===
shim (15.4-7~deb10u1) buster; urgency=high

  * Tweak how we call grub-install; don't abort on error. Not ideal
    behaviour either, but don't break upgrades. Copy the behaviour
    from the grub packages here. Bug #990966

 -- Steve McIntyre <93sam@debian.org>  Mon, 12 Jul 2021 08:59:53 +0100

shim (15.4-6~deb10u1) buster; urgency=high

  * Add arm64 patch to tweak section layout and stop crashing
    problems. Upstream issue #371. Closes: #990082, #990190
  * In insecure mode, don't abort if we can't create the MokListXRT
    variable. Upstream issue #372. Closes: #989962, #990158

 -- Steve McIntyre <93sam@debian.org>  Wed, 23 Jun 2021 19:08:54 +0100

shim (15.4-5~deb10u1) buster; urgency=medium

  * Add defensive code around calls to db_get. Don't fail if they
    return errors.

 -- Steve McIntyre <93sam@debian.org>  Sat, 08 May 2021 00:14:00 +0100

shim (15.4-4~deb10u1) unstable; urgency=medium

  * Fix up those maintainer scripts - if we're not running on an EFI
    system then exit cleanly.

 -- Steve McIntyre <93sam@debian.org>  Mon, 03 May 2021 21:31:33 +0100

shim (15.4-3~deb10u1) buster; urgency=medium

  * Add maintainer scripts to the template packages to manage
    installing and removing fbXXX.efi and mmXXX.efi when we
    install/remove the shim-helpers-$arch-signed packages.
    Closes: #966845

 -- Steve McIntyre <93sam@debian.org>  Mon, 03 May 2021 21:31:33 +0100

shim (15.4-2~deb10u1) buster; urgency=medium

  * Add two further patches from upstream:
    + fix import_one_mok_state() after split
    + Don't call QueryVariableInfo() on EFI 1.10 machines (e.g. older
      Intel Mac machines)

 -- Steve McIntyre <93sam@debian.org>  Wed, 21 Apr 2021 01:06:27 +0100

shim (15.4-1~deb10u1) buster; urgency=medium

  * New upstream release fixing more bugs: SBAT and arm64 support
  * Print sha256 checksums of the EFI binaries when the build is done
  * Add two patches from upstream:
    + fix i386 binary relocations
    + allocate MOK config table as BootServicesData

 -- Steve McIntyre <93sam@debian.org>  Wed, 31 Mar 2021 19:56:02 +0100

shim (15.3-1~deb10u3) buster; urgency=medium

  * Only include the upstream version in the Debian SBAT metadata, so
    we don't break reproducibility on every minor packaging change.

 -- Steve McIntyre <93sam@debian.org>  Wed, 24 Mar 2021 13:31:51 +0000

shim (15.3-1~deb10u2) buster; urgency=medium

  * Add missing build-dep on xxd for build-time unit tests

 -- Steve McIntyre <93sam@debian.org>  Wed, 24 Mar 2021 02:26:22 +0000

shim (15.3-1~deb10u1) buster; urgency=medium

  * Rebuild the new upstream version for buster
  * Switch to gcc-8 for building
  * Switch to much-newer release with many fixes
    + Particularly pulling in SBAT changes for better revocation support
    + Remove all our old patches, no longer needed:
      - avoid_null_vsprint.patch
      - check_null_sn_ln.patch
      - fixup_git.patch
      - uname.patch
      - use_compare_mem_gcc9.patch
    + Now includes a vendor copy of gnu-efi with quite a few extra
      fixes needed.
    + Update copyright file to cover these changes
  * Add dbx entries for all our existing grub binaries
    + They're insecure, let's break the chainloading hole.
  * Add Debian SBAT data
    + Add a Debian SBAT template, and rules to use it
    + Adds a build-dep on dos2unix

 -- Steve McIntyre <93sam@debian.org>  Wed, 24 Mar 2021 01:09:20 +0000

shim (15+1533136590.3beb971-10) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Use secure copyright file specification URI.
  * debian/copyright: use spaces rather than tabs to start continuation
    lines.
  * Bump debhelper from old 11 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Update standards version to 4.4.1, no changes needed.

  [ Steve McIntyre ]
  * Trivial changes to generating the inbuilt dbx if we're using it.
  * Upload to pick up rotated Debian signing keys

 -- Steve McIntyre <93sam@debian.org>  Fri, 24 Jul 2020 01:22:46 +0100

shim (15+1533136590.3beb971-9) unstable; urgency=medium

  [ Steve McIntyre ]

  * In the -helpers-ARCH-signed packages, change the version
    dependency on shim-unsigned to be >= and not =. This will allow
    for installation to still work in the window while we wait for the
    template package to do its second trip through the
    archive. Closes: #955356

 -- Steve McIntyre <93sam@debian.org>  Fri, 24 Jul 2020 00:57:16 +0100

shim (15+1533136590.3beb971-8) unstable; urgency=medium

  [ Steve McIntyre ]
  * Use --padding when calling pesign to generate hashes for the dbx
    list, as recommended by Peter Jones. No actual changes needed in
    our list of hashes at this point - they work out the same either
    way.
  * Switch to using gcc-9 for builds, tweaking a patch from upstream
    to fix a FTBFS. Closes: #925816
  * Update debhelper compat level to 11 for shim and the
    signing-template

 -- Steve McIntyre <93sam@debian.org>  Tue, 24 Mar 2020 16:51:10 +0000

=== debian/control ===
Source: shim
Section: admin
Priority: optional
Maintainer: Debian EFI team <debian-efi@lists.debian.org>
Uploaders: Steve Langasek <vorlon@debian.org>, Steve McIntyre <93sam@debian.org>
Standards-Version: 4.3.0
Build-Depends: debhelper-compat (= 9),
	       sbsigntool,
	       openssl,
	       libelf-dev,
	       gcc-8,
	       dos2unix,
	       pesign (>= 0.112-5),
	       xxd
Vcs-Browser: https://salsa.debian.org/efi-team/shim
Vcs-Git: https://salsa.debian.org/efi-team/shim.git

Package: shim-unsigned
Architecture: amd64 arm64 i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: shim (<< 15+1533136590.3beb971-3~),
Replaces: shim (<< 15+1533136590.3beb971-3~),
Description: boot loader to chain-load signed boot loaders under Secure Boot
 This package provides a minimalist boot loader which allows verifying
 signatures of other UEFI binaries against either the Secure Boot DB/DBX or
 against a built-in signature database.  Its purpose is to allow a small,
 infrequently-changing binary to be signed by the UEFI CA, while allowing
 an OS distributor to revision their main bootloader independently of the CA.

Package: shim-helpers-amd64-signed-template
Architecture: amd64
Depends: ${misc:Depends},
Description: boot loader to chain-load signed boot loaders (signing template)
 This package contains template files for shim-helpers-amd64-signed.
 This is only needed for Secure Boot signing.

Package: shim-helpers-i386-signed-template
Architecture: i386
Depends: ${misc:Depends},
Description: boot loader to chain-load signed boot loaders (signing template)
 This package contains template files for shim-helpers-i386-signed.
 This is only needed for Secure Boot signing.

Package: shim-helpers-arm64-signed-template
Architecture: arm64
Depends: ${misc:Depends},
Description: boot loader to chain-load signed boot loaders (signing template)
 This package contains template files for shim-helpers-arm64-signed.
 This is only needed for Secure Boot signing.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

# Other vendors, add your certs here.  No sense in using
# dpkg-vendor --derives-from, because only Canonical-generated binaries will
# be signed with this key; so if you are building your own shim binary you
# should be building the other binaries also.
ifeq ($(shell dpkg-vendor --is ubuntu && echo yes),yes)
	cert=debian/canonical-uefi-ca.der
	distributor=ubuntu
COMMON_OPTIONS ?= ENABLE_SHIM_CERT=1 ENABLE_SBSIGN=1
else
	cert=debian/debian-uefi-ca.der
	distributor=debian
endif

deb_version             := $(shell dpkg-parsechangelog | sed -ne "s/^Version: \(.*\)/\1/p")
upstream_version        := $(shell echo $(deb_version) | sed -e "s/-[^-]*$$//")
plain_upstream_version  := $(shell echo $(upstream_version) | sed -e "s/+dfsg.*//")

DBX_LIST = dbx.esl
DBX_HASHES = debian/$(distributor)-dbx.hashes
SBAT_IN = debian/sbat.$(distributor).csv.in
SBAT_DATA = data/sbat.$(distributor).csv

include /usr/share/dpkg/architecture.mk

ifeq ($(DEB_HOST_ARCH),amd64)
export EFI_ARCH := x64
endif
ifeq ($(DEB_HOST_ARCH),arm64)
export EFI_ARCH := aa64
endif
ifeq ($(DEB_HOST_ARCH),i386)
export EFI_ARCH := ia32
endif

COMMON_OPTIONS += \
	RELEASE=$(plain_upstream_version) \
	COMMIT_ID=XXXX \
	MAKELEVEL=0 \
	ENABLE_HTTPBOOT=true \
	VENDOR_CERT_FILE=$(cert) \
	VENDOR_DBX_FILE=$(DBX_LIST) \
	EFIDIR=$(distributor) \
	CROSS_COMPILE=$(DEB_HOST_GNU_TYPE)- \
	CC=$(DEB_HOST_GNU_TYPE)-gcc-8 \
	$(NULL)

$(DBX_LIST): $(DBX_HASHES)
	./debian/generate_dbx_list $(EFI_ARCH) $< $@

$(SBAT_DATA): $(SBAT_IN)
	rm -f $@
	set -e; \
	sed -e "s/@DEB_VERSION@/$(deb_version)/g" \
		-e "s/@UPSTREAM_VERSION@/$(plain_upstream_version)/g" \
		< $(SBAT_IN) > $(SBAT_DATA)
	# If we have an empty $(SBAT_DATA), delete
	if [ ! -s $(SBAT_DATA) ]; then rm -f $(SBAT_DATA); fi

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean -- MAKELEVEL=0
	rm -f $(DBX_LIST) $(SBAT_DATA) sbat.*.csv BOOT*.CSV test-csv test-sbat test-str

override_dh_auto_build: $(DBX_LIST) $(SBAT_DATA)
	dh_auto_build -- $(COMMON_OPTIONS)

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp -- $(COMMON_OPTIONS)
	# Remove the copy of the source that's installed - we have git
	# already...
	rm -rf debian/tmp/usr
	# And remove the extra removable-media copy of shim too, it's
	# not needed for our build and causes debhelper to complain
	rm -f debian/tmp/boot/efi/EFI/BOOT/BOOT*.EFI
	./debian/signing-template.generate
	sha256sum *.efi

generate-gnu-efi:
	git -C gnu-efi archive --prefix=gnu-efi/ HEAD | xz -9 \
		> ../shim_$(plain_upstream_version).orig-gnu-efi.tar.xz

## shim 15.4-7+11.0trisquel0

=== Makefile ===
--- 
+++ 
@@ -244,7 +244,7 @@
 	$(OBJCOPY) -D -j .text -j .sdata -j .data -j .data.ident \
 		-j .dynamic -j .rodata -j .rel* \
 		-j .rela* -j .reloc -j .eh_frame \
-		-j .vendor_cert -j .sbat \
+		-j .vendor_cert -j .dyn -j .sbat \
 		$(FORMAT) $< $@
 	# I am tired of wasting my time fighting binutils timestamp code.
 	dd conv=notrunc bs=1 count=4 seek=$(TIMESTAMP_LOCATION) if=/dev/zero of=$@
@@ -260,7 +260,7 @@
 endif
 	$(OBJCOPY) -D -j .text -j .sdata -j .data \
 		-j .dynamic -j .rodata -j .rel* \
-		-j .rela* -j .reloc -j .eh_frame -j .sbat \
+		-j .rela* -j .dyn -j .reloc -j .eh_frame -j .sbat \
 		-j .debug_info -j .debug_abbrev -j .debug_aranges \
 		-j .debug_line -j .debug_str -j .debug_ranges \
 		-j .note.gnu.build-id \

=== debian/changelog ===
shim (15.4-7+11.0trisquel0) aramo; urgency=medium

  * Rebuild to get unsigned binary as dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Fri, 04 Nov 2022 01:14:52 +0000

shim (15.4-7) unstable; urgency=high

  * Tweak how we call grub-install; don't abort on error. Not ideal
    behaviour either, but don't break upgrades. Copy the behaviour
    from the grub packages here. Closes: #990966

 -- Steve McIntyre <93sam@debian.org>  Mon, 12 Jul 2021 08:53:54 +0100

shim (15.4-6) unstable; urgency=high

  * Add arm64 patch to tweak section layout and stop crashing
    problems. Upstream issue #371. Closes: #990082, #990190
  * In insecure mode, don't abort if we can't create the MokListXRT
    variable. Upstream issue #372. Closes: #989962, #990158

 -- Steve McIntyre <93sam@debian.org>  Wed, 23 Jun 2021 19:03:54 +0100

shim (15.4-5) unstable; urgency=medium

  * Add defensive code around calls to db_get. Don't fail if they
    return errors.

 -- Steve McIntyre <93sam@debian.org>  Thu, 06 May 2021 00:37:49 +0100

shim (15.4-4) unstable; urgency=medium

  * Fix up those maintainer scripts - if we're not running on an EFI
    system then exit cleanly.

 -- Steve McIntyre <93sam@debian.org>  Tue, 04 May 2021 17:53:21 +0100

shim (15.4-3) unstable; urgency=medium

  * Add maintainer scripts to the template packages to manage
    installing and removing fbXXX.efi and mmXXX.efi when we
    install/remove the shim-helpers-$arch-signed packages.
    Closes: #966845

 -- Steve McIntyre <93sam@debian.org>  Mon, 03 May 2021 20:48:49 +0100

shim (15.4-2) unstable; urgency=medium

  * Add two further patches from upstream:
    + fix import_one_mok_state() after split
    + Don't call QueryVariableInfo() on EFI 1.10 machines (e.g. older
      Intel Mac machines)

 -- Steve McIntyre <93sam@debian.org>  Wed, 21 Apr 2021 00:23:02 +0100

shim (15.4-1) unstable; urgency=medium

  * New upstream release fixing more bugs: SBAT and arm64 support
  * Print sha256 checksums of the EFI binaries when the build is done
  * Add two patches from upstream:
    + fix i386 binary relocations
    + allocate MOK config table as BootServicesData

 -- Steve McIntyre <93sam@debian.org>  Wed, 31 Mar 2021 18:25:00 +0100

shim (15.3-3) unstable; urgency=medium

  * Update the timestamp for the 15.3-2 upload.
  * Only include the upstream version in the Debian SBAT metadata, so
    we don't break reproducibility on every minor packaging change.

 -- Steve McIntyre <93sam@debian.org>  Wed, 24 Mar 2021 13:21:05 +0000

shim (15.3-2) unstable; urgency=medium

  * Add missing build-dep on xxd for build-time unit tests

 -- Steve McIntyre <93sam@debian.org>  Wed, 24 Mar 2021 02:21:53 +0000

shim (15.3-1) unstable; urgency=medium

  [ Steve McIntyre ]
  * Switch to much-newer release with many fixes
    + Particularly pulling in SBAT changes for better revocation support
    + Remove all our old patches, no longer needed:
      - avoid_null_vsprint.patch
      - check_null_sn_ln.patch
      - fixup_git.patch
      - uname.patch
      - use_compare_mem_gcc9.patch
    + Now includes a vendor copy of gnu-efi with quite a few extra
      fixes needed.
    + Update copyright file to cover these changes
  * Switch to using gcc-10 rather than gcc-9. Closes: #978521
  * Add dbx entries for all our existing grub binaries
    + They're insecure, let's break the chainloading hole.
  * Add Debian SBAT data
    + Add a Debian SBAT template, and rules to use it
    + Adds a build-dep on dos2unix

 -- Steve McIntyre <93sam@debian.org>  Tue, 23 Mar 2021 23:39:48 +0000

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,15 @@
 Source: shim
 Section: admin
 Priority: optional
-Maintainer: Debian EFI team <debian-efi@lists.debian.org>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 Uploaders: Steve Langasek <vorlon@debian.org>, Steve McIntyre <93sam@debian.org>
-Standards-Version: 4.3.0
-Build-Depends: debhelper-compat (= 9),
+Standards-Version: 4.4.1
+Build-Depends: debhelper-compat (= 12),
+	       gnu-efi (>= 3.0u),
 	       sbsigntool,
 	       openssl,
 	       libelf-dev,
-	       gcc-8,
+	       gcc-10,
 	       dos2unix,
 	       pesign (>= 0.112-5),
 	       xxd

## shim 15.4.1

=== debian/changelog ===
shim (15.4.1-7) UNRELEASED; urgency=medium

  * update

 -- Debian EFI team <debian-efi@lists.debian.org>  Fri, 27 May 2022 14:04:03 +0800

shim (15.4.1-7) unstable; urgency=medium

  * 添加UOS，deepin编译支持
  * 添加UOS，deepin证书
  * 更新编译依赖gcc-10 -> gcc-11

 -- zhouzilong <zhouzilong@uniontech.com>  Thu, 26 May 2022 11:41:58 +0800

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: shim
 Section: admin
 Priority: optional
-Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
+Maintainer: Debian EFI team <debian-efi@lists.debian.org>
 Uploaders: Steve Langasek <vorlon@debian.org>, Steve McIntyre <93sam@debian.org>
 Standards-Version: 4.4.1
 Build-Depends: debhelper-compat (= 12),
@@ -9,7 +9,7 @@
 	       sbsigntool,
 	       openssl,
 	       libelf-dev,
-	       gcc-10,
+	       gcc-11,
 	       dos2unix,
 	       pesign (>= 0.112-5),
 	       xxd

=== debian/rules ===
--- 
+++ 
@@ -6,10 +6,12 @@
 # dpkg-vendor --derives-from, because only Canonical-generated binaries will
 # be signed with this key; so if you are building your own shim binary you
 # should be building the other binaries also.
-ifeq ($(shell dpkg-vendor --is ubuntu && echo yes),yes)
-	cert=debian/canonical-uefi-ca.der
-	distributor=ubuntu
-COMMON_OPTIONS ?= ENABLE_SHIM_CERT=1 ENABLE_SBSIGN=1
+ifeq ($(shell dpkg-vendor --is deepin && echo yes),yes)
+	cert=debian/deepin-uefi-ca.der
+	distributor=deepin
+else ifeq ($(shell dpkg-vendor --is uos && echo yes),yes)
+    cert=debian/UOS-UEFI-RSA.cer
+    distributor=uos
 else
 	cert=debian/debian-uefi-ca.der
 	distributor=debian
@@ -45,7 +47,7 @@
 	VENDOR_DBX_FILE=$(DBX_LIST) \
 	EFIDIR=$(distributor) \
 	CROSS_COMPILE=$(DEB_HOST_GNU_TYPE)- \
-	CC=$(DEB_HOST_GNU_TYPE)-gcc-8 \
+	CC=$(DEB_HOST_GNU_TYPE)-gcc-11 \
 	$(NULL)
 
 $(DBX_LIST): $(DBX_HASHES)
@@ -68,10 +70,10 @@
 	rm -f $(DBX_LIST) $(SBAT_DATA) sbat.*.csv BOOT*.CSV test-csv test-sbat test-str
 
 override_dh_auto_build: $(DBX_LIST) $(SBAT_DATA)
-	dh_auto_build -- $(COMMON_OPTIONS)
+	dh_auto_build -- INSTALL=install $(COMMON_OPTIONS)
 
 override_dh_auto_install:
-	dh_auto_install --destdir=debian/tmp -- $(COMMON_OPTIONS)
+	dh_auto_install --destdir=debian/tmp -- INSTALL=install $(COMMON_OPTIONS)
 	# Remove the copy of the source that's installed - we have git
 	# already...
 	rm -rf debian/tmp/usr

## shim 15.6

=== debian/changelog ===
shim (15.6-1~deb10u1) buster; urgency=medium

  * New upstream release fixing more bugs
    + Remove all our old patches, all now upstream:
      - fix-32b-format-strings.patch
      - fix-test-includes.patch
  * Rebuild for buster
    + Add new patches reverting arm64 build system changes so we can
      build using older binutils.

 -- Steve McIntyre <93sam@debian.org>  Thu, 28 Jul 2022 07:46:16 +0100

=== debian/rules ===
--- 
+++ 
@@ -6,12 +6,10 @@
 # dpkg-vendor --derives-from, because only Canonical-generated binaries will
 # be signed with this key; so if you are building your own shim binary you
 # should be building the other binaries also.
-ifeq ($(shell dpkg-vendor --is deepin && echo yes),yes)
-	cert=debian/deepin-uefi-ca.der
-	distributor=deepin
-else ifeq ($(shell dpkg-vendor --is uos && echo yes),yes)
-    cert=debian/UOS-UEFI-RSA.cer
-    distributor=uos
+ifeq ($(shell dpkg-vendor --is ubuntu && echo yes),yes)
+	cert=debian/canonical-uefi-ca.der
+	distributor=ubuntu
+COMMON_OPTIONS ?= ENABLE_SHIM_CERT=1 ENABLE_SBSIGN=1
 else
 	cert=debian/debian-uefi-ca.der
 	distributor=debian
@@ -47,7 +45,7 @@
 	VENDOR_DBX_FILE=$(DBX_LIST) \
 	EFIDIR=$(distributor) \
 	CROSS_COMPILE=$(DEB_HOST_GNU_TYPE)- \
-	CC=$(DEB_HOST_GNU_TYPE)-gcc-11 \
+	CC=$(DEB_HOST_GNU_TYPE)-gcc-8 \
 	$(NULL)
 
 $(DBX_LIST): $(DBX_HASHES)
@@ -70,10 +68,13 @@
 	rm -f $(DBX_LIST) $(SBAT_DATA) sbat.*.csv BOOT*.CSV test-csv test-sbat test-str
 
 override_dh_auto_build: $(DBX_LIST) $(SBAT_DATA)
-	dh_auto_build -- INSTALL=install $(COMMON_OPTIONS)
+	dh_auto_build -- $(COMMON_OPTIONS)
+
+override_dh_auto_test: $(DBX_LIST) $(SBAT_DATA)
+	dh_auto_test -- INSTALL=install $(COMMON_OPTIONS)
 
 override_dh_auto_install:
-	dh_auto_install --destdir=debian/tmp -- INSTALL=install $(COMMON_OPTIONS)
+	dh_auto_install --destdir=debian/tmp -- $(COMMON_OPTIONS)
 	# Remove the copy of the source that's installed - we have git
 	# already...
 	rm -rf debian/tmp/usr

## shim 15.7

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 default : all
 
 NAME		= shim
-VERSION		= 15.4
+VERSION		= 15.7
 ifneq ($(origin RELEASE),undefined)
 DASHRELEASE	?= -$(RELEASE)
 else
@@ -38,12 +38,12 @@
 else
 TARGETS += $(MMNAME) $(FBNAME)
 endif
-OBJS	= shim.o mok.o netboot.o cert.o replacements.o tpm.o version.o errlog.o sbat.o sbat_data.o pe.o httpboot.o csv.o
+OBJS	= shim.o globals.o mok.o netboot.o cert.o replacements.o tpm.o version.o errlog.o sbat.o sbat_data.o sbat_var.o pe.o httpboot.o csv.o load-options.o
 KEYS	= shim_cert.h ocsp.* ca.* shim.crt shim.csr shim.p12 shim.pem shim.key shim.cer
-ORIG_SOURCES	= shim.c mok.c netboot.c replacements.c tpm.c errlog.c sbat.c pe.c httpboot.c shim.h version.h $(wildcard include/*.h)
-MOK_OBJS = MokManager.o PasswordCrypt.o crypt_blowfish.o errlog.o sbat_data.o
+ORIG_SOURCES	= shim.c globals.c mok.c netboot.c replacements.c tpm.c errlog.c sbat.c pe.c httpboot.c shim.h version.h $(wildcard include/*.h) cert.S sbat_var.S
+MOK_OBJS = MokManager.o PasswordCrypt.o crypt_blowfish.o errlog.o sbat_data.o globals.o
 ORIG_MOK_SOURCES = MokManager.c PasswordCrypt.c crypt_blowfish.c shim.h $(wildcard include/*.h)
-FALLBACK_OBJS = fallback.o tpm.o errlog.o sbat_data.o
+FALLBACK_OBJS = fallback.o tpm.o errlog.o sbat_data.o globals.o
 ORIG_FALLBACK_SRCS = fallback.c
 SBATPATH = $(TOPDIR)/data/sbat.csv
 
@@ -59,6 +59,10 @@
 
 ifneq ($(origin FALLBACK_VERBOSE), undefined)
 	CFLAGS += -DFALLBACK_VERBOSE
+endif
+
+ifneq ($(origin FALLBACK_NONINTERACTIVE), undefined)
+	CFLAGS += -DFALLBACK_NONINTERACTIVE
 endif
 
 ifneq ($(origin FALLBACK_VERBOSE_WAIT), undefined)
@@ -103,9 +107,6 @@
 shim.o: shim_cert.h
 endif
 shim.o: $(wildcard $(TOPDIR)/*.h)
-
-cert.o : $(TOPDIR)/cert.S
-	$(CC) $(CFLAGS) -c -o $@ $<
 
 sbat.%.csv : data/sbat.%.csv
 	$(DOS2UNIX) $(D2UFLAGS) $< $@
@@ -121,9 +122,10 @@
 		$@
 	$(foreach vs,$(VENDOR_SBATS),$(call add-vendor-sbat,$(vs),$@))
 
-$(SHIMNAME) : $(SHIMSONAME)
-$(MMNAME) : $(MMSONAME)
-$(FBNAME) : $(FBSONAME)
+$(SHIMNAME) : $(SHIMSONAME) post-process-pe
+$(MMNAME) : $(MMSONAME) post-process-pe
+$(FBNAME) : $(FBSONAME) post-process-pe
+$(SHIMNAME) $(MMNAME) $(FBNAME) : | post-process-pe
 
 LIBS = Cryptlib/libcryptlib.a \
        Cryptlib/OpenSSL/libopenssl.a \
@@ -148,7 +150,11 @@
 gnu-efi/$(ARCH_GNUEFI)/gnuefi/libgnuefi.a gnu-efi/$(ARCH_GNUEFI)/lib/libefi.a:
 	mkdir -p gnu-efi/lib gnu-efi/gnuefi
 	$(MAKE) -C gnu-efi \
-		ARCH=$(ARCH_GNUEFI) TOPDIR=$(TOPDIR)/gnu-efi \
+		COMPILER="$(COMPILER)" \
+		CCC_CC="$(COMPILER)" \
+		CC="$(CC)" \
+		ARCH=$(ARCH_GNUEFI) \
+		TOPDIR=$(TOPDIR)/gnu-efi \
 		-f $(TOPDIR)/gnu-efi/Makefile \
 		lib gnuefi inc
 
@@ -163,6 +169,9 @@
 lib/lib.a: | $(TOPDIR)/lib/Makefile $(wildcard $(TOPDIR)/include/*.[ch])
 	mkdir -p lib
 	$(MAKE) VPATH=$(TOPDIR)/lib TOPDIR=$(TOPDIR) -C lib -f $(TOPDIR)/lib/Makefile
+
+post-process-pe : $(TOPDIR)/post-process-pe.c
+	$(HOSTCC) -std=gnu11 -Og -g3 -Wall -Wextra -Wno-missing-field-initializers -Werror -o $@ $<
 
 buildid : $(TOPDIR)/buildid.c
 	$(HOSTCC) -I/usr/include -Og -g3 -Wall -Werror -Wextra -o $@ $< -lelf
@@ -243,11 +252,10 @@
 endif
 	$(OBJCOPY) -D -j .text -j .sdata -j .data -j .data.ident \
 		-j .dynamic -j .rodata -j .rel* \
-		-j .rela* -j .reloc -j .eh_frame \
-		-j .vendor_cert -j .dyn -j .sbat \
+		-j .rela* -j .dyn -j .reloc -j .eh_frame \
+		-j .vendor_cert -j .sbat -j .sbatlevel \
 		$(FORMAT) $< $@
-	# I am tired of wasting my time fighting binutils timestamp code.
-	dd conv=notrunc bs=1 count=4 seek=$(TIMESTAMP_LOCATION) if=/dev/zero of=$@
+	./post-process-pe -vv $@
 
 ifneq ($(origin ENABLE_SHIM_HASH),undefined)
 %.hash : %.efi
@@ -261,6 +269,7 @@
 	$(OBJCOPY) -D -j .text -j .sdata -j .data \
 		-j .dynamic -j .rodata -j .rel* \
 		-j .rela* -j .dyn -j .reloc -j .eh_frame -j .sbat \
+		-j .sbatlevel \
 		-j .debug_info -j .debug_abbrev -j .debug_aranges \
 		-j .debug_line -j .debug_str -j .debug_ranges \
 		-j .note.gnu.build-id \
@@ -277,8 +286,14 @@
 	$(PESIGN) -n certdb -i $< -c "shim" -s -o $@ -f
 endif
 
-test :
-	@make -f $(TOPDIR)/include/test.mk EFI_INCLUDES="$(EFI_INCLUDES)" ARCH_DEFINES="$(ARCH_DEFINES)" all
+test test-clean test-coverage test-lto :
+	@make -f $(TOPDIR)/include/test.mk \
+		COMPILER="$(COMPILER)" \
+		CROSS_COMPILE="$(CROSS_COMPILE)" \
+		CLANG_WARNINGS="$(CLANG_WARNINGS)" \
+		ARCH_DEFINES="$(ARCH_DEFINES)" \
+		EFI_INCLUDES="$(EFI_INCLUDES)" \
+		test-clean $@
 
 $(patsubst %.c,%,$(wildcard test-*.c)) :
 	@make -f $(TOPDIR)/include/test.mk EFI_INCLUDES="$(EFI_INCLUDES)" ARCH_DEFINES="$(ARCH_DEFINES)" $@
@@ -291,7 +306,11 @@
 clean-gnu-efi:
 	@if [ -d gnu-efi ] ; then \
 		$(MAKE) -C gnu-efi \
-			ARCH=$(ARCH_GNUEFI) TOPDIR=$(TOPDIR)/gnu-efi \
+			CC="$(CC)" \
+			HOSTCC="$(HOSTCC)" \
+			COMPILER="$(COMPILER)" \
+			ARCH=$(ARCH_GNUEFI) \
+			TOPDIR=$(TOPDIR)/gnu-efi \
 			-f $(TOPDIR)/gnu-efi/Makefile \
 			clean ; \
 	fi
@@ -303,7 +322,7 @@
 
 clean-shim-objs:
 	@rm -rvf $(TARGET) *.o $(SHIM_OBJS) $(MOK_OBJS) $(FALLBACK_OBJS) $(KEYS) certdb $(BOOTCSVNAME)
-	@rm -vf *.debug *.so *.efi *.efi.* *.tar.* version.c buildid
+	@rm -vf *.debug *.so *.efi *.efi.* *.tar.* version.c buildid post-process-pe
 	@rm -vf Cryptlib/*.[oa] Cryptlib/*/*.[oa]
 	@if [ -d .git ] ; then git clean -f -d -e 'Cryptlib/OpenSSL/*'; fi
 
@@ -329,9 +348,3 @@
 	git tag -f latest-release $(GITTAG)
 
 archive: tag
-	@./make-archive $(if $(call get-config,shim.origin),--origin "$(call get-config,shim.origin)") --release "$(VERSION)" "$(GITTAG)" "shim-$(GITTAG)"
-
-.PHONY : install-deps shim.key
-
-export ARCH CC CROSS_COMPILE LD OBJCOPY EFI_INCLUDE EFI_INCLUDES OPTIMIZATIONS
-export FEATUREFLAGS WARNFLAGS WERRFLAGS

=== debian/changelog ===
shim (15.7-1) unstable; urgency=medium

  * New upstream release fixing more bugs
  * Add further patches from upstream:
    + Make sbat_var.S parse right with buggy gcc/binutils
    + Enable NX support at build time, as required by policy for signing
      new shim binaries.
  * Switch to using gcc-12. Closes: #1022180
  * Update to Standards-Version 4.6.2 (no changes needed)
  * Block Debian grub binaries with sbat < 4 (see #1024617)

 -- Steve McIntyre <93sam@debian.org>  Mon, 30 Jan 2023 18:11:23 +0000

shim (15.6-1) unstable; urgency=medium

  * New upstream release fixing more bugs
    + Remove all our old patches, all now upstream:
      - fix-32b-format-strings.patch
      - fix-test-includes.patch

 -- Steve McIntyre <93sam@debian.org>  Thu, 21 Jul 2022 14:04:01 +0200

shim (15.5-1) UNRELEASED; urgency=medium

  * New upstream release fixing more bugs
    + Remove all our old patches, all now upstream:
      - Don-t-call-QueryVariableInfo-on-EFI-1.10-machines.patch
      - MOK-BootServicesData.patch
      -	fix-broken-ia32-reloc.patch
      -	fix-import_one_mok_state.patch
      - fix_arm64_rela_sections.patch
      - relax_check_for_import_mok_state.patch
  * Fix format strings for 32-bit builds
  * Tweak setup for dh_auto_test so the tests work
  * Add new build-dep on libefivar-dev for tests

 -- Steve McIntyre <93sam@debian.org>  Wed, 27 Apr 2022 22:50:08 +0100

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,17 @@
 Priority: optional
 Maintainer: Debian EFI team <debian-efi@lists.debian.org>
 Uploaders: Steve Langasek <vorlon@debian.org>, Steve McIntyre <93sam@debian.org>
-Standards-Version: 4.4.1
+Standards-Version: 4.6.2
 Build-Depends: debhelper-compat (= 12),
 	       gnu-efi (>= 3.0u),
 	       sbsigntool,
 	       openssl,
 	       libelf-dev,
-	       gcc-11,
+	       gcc-12,
 	       dos2unix,
 	       pesign (>= 0.112-5),
-	       xxd
+	       xxd,
+	       libefivar-dev
 Vcs-Browser: https://salsa.debian.org/efi-team/shim
 Vcs-Git: https://salsa.debian.org/efi-team/shim.git

=== debian/rules ===
--- 
+++ 
@@ -38,14 +38,14 @@
 
 COMMON_OPTIONS += \
 	RELEASE=$(plain_upstream_version) \
-	COMMIT_ID=XXXX \
+	COMMIT_ID=657b2483ca6e9fcf2ad8ac7ee577ff546d24c3aa \
 	MAKELEVEL=0 \
 	ENABLE_HTTPBOOT=true \
 	VENDOR_CERT_FILE=$(cert) \
 	VENDOR_DBX_FILE=$(DBX_LIST) \
 	EFIDIR=$(distributor) \
 	CROSS_COMPILE=$(DEB_HOST_GNU_TYPE)- \
-	CC=$(DEB_HOST_GNU_TYPE)-gcc-8 \
+	CC=$(DEB_HOST_GNU_TYPE)-gcc-12 \
 	$(NULL)
 
 $(DBX_LIST): $(DBX_HASHES)
@@ -68,13 +68,13 @@
 	rm -f $(DBX_LIST) $(SBAT_DATA) sbat.*.csv BOOT*.CSV test-csv test-sbat test-str
 
 override_dh_auto_build: $(DBX_LIST) $(SBAT_DATA)
-	dh_auto_build -- $(COMMON_OPTIONS)
+	dh_auto_build -- INSTALL=install $(COMMON_OPTIONS)
 
 override_dh_auto_test: $(DBX_LIST) $(SBAT_DATA)
 	dh_auto_test -- INSTALL=install $(COMMON_OPTIONS)
 
 override_dh_auto_install:
-	dh_auto_install --destdir=debian/tmp -- $(COMMON_OPTIONS)
+	dh_auto_install --destdir=debian/tmp -- INSTALL=install $(COMMON_OPTIONS)
 	# Remove the copy of the source that's installed - we have git
 	# already...
 	rm -rf debian/tmp/usr

## shim 15.7-1~deb11u1+11.0trisquel0

=== Makefile ===
--- 
+++ 
@@ -255,7 +255,7 @@
 		-j .rela* -j .dyn -j .reloc -j .eh_frame \
 		-j .vendor_cert -j .sbat -j .sbatlevel \
 		$(FORMAT) $< $@
-	./post-process-pe -vv $@
+	./post-process-pe -vv $(POST_PROCESS_PE_FLAGS) $@
 
 ifneq ($(origin ENABLE_SHIM_HASH),undefined)
 %.hash : %.efi

=== debian/changelog ===
shim (15.7-1~deb11u1+11.0trisquel0) aramo; urgency=medium

  * Rebuild to get unsigned binary as dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Sat, 29 Apr 2023 12:41:51 +0000

shim (15.7-1~deb11u1) bullseye; urgency=medium

  * New upstream release fixing more bugs
  * Add further patches from upstream:
    + Make sbat_var.S parse right with buggy gcc/binutils
    + Enable NX support at build time, as required by policy for signing
      new shim binaries.
  * Block Debian grub binaries with sbat < 4 (see #1024617)
  * Rebuild for bullseye
    + Add patches reverting arm64 build system changes so we can
      build using older binutils.

 -- Steve McIntyre <93sam@debian.org>  Tue, 31 Jan 2023 10:41:03 +0100

shim (15.6-1~deb11u1) bullseye; urgency=medium

  * New upstream release fixing more bugs
    + Remove all our old patches, all now upstream:
      - fix-32b-format-strings.patch
      - fix-test-includes.patch
  * Rebuild for bullseye
    + Add new patches reverting arm64 build system changes so we can
      build using older binutils.

 -- Steve McIntyre <93sam@debian.org>  Thu, 28 Jul 2022 08:22:35 +0100

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,15 @@
 Source: shim
 Section: admin
 Priority: optional
-Maintainer: Debian EFI team <debian-efi@lists.debian.org>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 Uploaders: Steve Langasek <vorlon@debian.org>, Steve McIntyre <93sam@debian.org>
-Standards-Version: 4.6.2
+Standards-Version: 4.4.1
 Build-Depends: debhelper-compat (= 12),
 	       gnu-efi (>= 3.0u),
 	       sbsigntool,
 	       openssl,
 	       libelf-dev,
-	       gcc-12,
+	       gcc-10,
 	       dos2unix,
 	       pesign (>= 0.112-5),
 	       xxd,

=== debian/rules ===
--- 
+++ 
@@ -38,14 +38,14 @@
 
 COMMON_OPTIONS += \
 	RELEASE=$(plain_upstream_version) \
-	COMMIT_ID=657b2483ca6e9fcf2ad8ac7ee577ff546d24c3aa \
+	COMMIT_ID=XXXX \
 	MAKELEVEL=0 \
 	ENABLE_HTTPBOOT=true \
 	VENDOR_CERT_FILE=$(cert) \
 	VENDOR_DBX_FILE=$(DBX_LIST) \
 	EFIDIR=$(distributor) \
 	CROSS_COMPILE=$(DEB_HOST_GNU_TYPE)- \
-	CC=$(DEB_HOST_GNU_TYPE)-gcc-12 \
+	CC=$(DEB_HOST_GNU_TYPE)-gcc-10 \
 	$(NULL)
 
 $(DBX_LIST): $(DBX_HASHES)
